void DiskEject(char ADisk,BOOL type)
{
  HANDLE DiskHandle;
  BOOL Retry=TRUE;
  DWORD temp;  
  BOOL ReadOnly=FALSE;

  char DiskPath[7];
  strcpy(DiskPath,"\\\\.\\ :");
  DiskPath[4]=ADisk;
  DiskHandle=CreateFile(DiskPath,GENERIC_READ|GENERIC_WRITE,
                        FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,
                        0,0);
  if((DiskHandle==INVALID_HANDLE_VALUE) && (GetLastError()==ERROR_ACCESS_DENIED))
  {
    DiskHandle=CreateFile(DiskPath,GENERIC_READ,
                          FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,
                          0,0);
    ReadOnly=FALSE;
  }
  if(DiskHandle!=INVALID_HANDLE_VALUE)
  {
    while(Retry)
      if(DeviceIoControl(DiskHandle,FSCTL_LOCK_VOLUME,NULL,0,NULL,0,&temp,NULL))
      {
        if(!ReadOnly)
          FlushFileBuffers(DiskHandle);
        PREVENT_MEDIA_REMOVAL PreventMediaRemoval;
        PreventMediaRemoval.PreventMediaRemoval=FALSE;
        if(DeviceIoControl(DiskHandle,IOCTL_STORAGE_MEDIA_REMOVAL,&PreventMediaRemoval,sizeof(PreventMediaRemoval),NULL,0,&temp,NULL))
        {
          if(!type)
            DeviceIoControl(DiskHandle,IOCTL_STORAGE_EJECT_MEDIA,NULL,0,NULL,0,&temp,NULL);
          else
            DeviceIoControl(DiskHandle,IOCTL_STORAGE_LOAD_MEDIA,NULL,0,NULL,0,&temp,NULL);
        }
        Retry=FALSE;
      }
      else
      {
        const char *MsgItems[]={"",GetMsg(mEjectRetry),GetMsg(mEjectCancel)};
        if(Info.Message(Info.ModuleNumber,FMSG_ERRORTYPE|FMSG_WARNING,NULL,MsgItems,sizeof(MsgItems)/sizeof(MsgItems[0]),2))
          Retry=FALSE;
      }
    DeviceIoControl(DiskHandle,FSCTL_UNLOCK_VOLUME,NULL,0,NULL,0,&temp,NULL);
    CloseHandle(DiskHandle);
  }
}

void ShowDiskMenu(BOOL type)
{
  DWORD Disks;
  int DiskCount=0;
  struct FarMenuItem *DiskMenuItems=NULL;
  Disks=GetLogicalDrives()&~3;
  {
    int i=Disks;
    while(i)
    {
      i&=i-1;
      DiskCount++;
    }
  }
  if(DiskCount)
  {
    DiskMenuItems=(struct FarMenuItem *)malloc(DiskCount*sizeof(struct FarMenuItem));
    if(DiskMenuItems)
    {
      for(int i=2,j=0;i<27;i++)
        if(Disks&(1<<i))
        {
          DiskMenuItems[j].Text[0]='&';
          DiskMenuItems[j].Text[1]='A'+i;
          DiskMenuItems[j].Text[2]=':';
          j++;
        }
      DiskMenuItems[0].Selected=TRUE;
    }
    int i=Info.Menu(Info.ModuleNumber,-1,-1,0,0,"",NULL,NULL,NULL,NULL,DiskMenuItems,DiskCount);
    if(i>-1)
      DiskEject(DiskMenuItems[i].Text[1],type);
    free(DiskMenuItems);
  }
}
